;**********************************************************************
;    Filename:	fcount.asm 
;    Date:          	2005/5/1
;    File Version:
;**********************************************************************

	list      		p=16F88			 ; list directive to define processor
	#include		 <p16F88.inc>		 ; processor specific variable definitions

	__CONFIG   _CONFIG1,  _CP_OFF & _WDT_OFF & _PWRTE_ON & _LVP_OFF & _MCLR_OFF & _EXTCLK

;***** VARIABLE DEFINITIONS
w_temp			EQU     0x20			 ; variable used for context saving 
status_temp		EQU     0x21			 ; variable used for context saving

wait_data		EQU	0x30		;wait data ram
taihi			EQU	0x31		;taihi data

tmr0_count1		EQU	0x34		;TMR0 overflow1
tmr0_count2		EQU	0x35		;TMR0 overflow2

tmr1_flg			EQU	0x38		;TMR1 check
wait_data_2		EQU	0x39		;wait data 2
data_s3			EQU	0x3a		;data(24)-(31)
data_s2			EQU	0x3b		;data(16)-(23)
data_s1			EQU	0x3c		;data(8)-(15)
data_s0			EQU	0x3d		;data(0)-(7)

hen_a			EQU	0x40		;10sin 10keta
hen_9			EQU	0x41		;10sin 9keta
hen_8			EQU	0x42		;10sin 8keta
hen_7			EQU	0x43		;10sin 7keta
hen_6			EQU	0x44		;10sin 6keta
hen_5			EQU	0x45		;10sin 5keta
hen_4			EQU	0x46		;10sin 4keta
hen_3			EQU	0x47		;10sin 3keta
hen_2			EQU	0x48		;10sin 2keta
hen_1			EQU	0x49		;10sin 1keta
dec_top			EQU	0x4a
sub_count		EQU	0x4a		;sub counter
sub_amari		EQU	0x4b		;sub amari

f_data1			EQU	0x50		;f_data 1keta
f_data2			EQU	0x51		;f_data 2keta
f_data3			EQU	0x52		;f_data 3keta
f_data4			EQU	0x53		;f_data 4keta
f_data5			EQU	0x55		;f_data 5keta

set_timer1		EQU	0e0h		;TMR1H set data (0.25sec)


;**********************************************************************
		ORG     		0x000			; processor reset vector
  		goto    		main			; go to beginning of program

;----------------------------------------------------------------------------------
		ORG     		0x004			; interrupt vector location
		movwf   	w_temp			; save off current W register contents
		movf		STATUS,w		; move status register into W register
		movwf		status_temp		; save off contents of STATUS register

		;---------------------------------	
		btfss		PIR1,TMR1IF
		goto		int_next3
		bcf			PIR1,TMR1IF
		movlw		set_timer1
		movwf		TMR1H

		btfsc		tmr1_flg,0
		goto		int_next2
		;--------------------------------- keisoku start
		clrf			TMR0
		clrf			tmr0_count1
		clrf			tmr0_count2
		;---
		bsf			tmr1_flg,0
		goto		int_next9
		;--------------------------------- keisoku end
int_next2
		nop
		nop
		nop
		;---
		movf		TMR0,0
		movwf		data_s0
		movf		tmr0_count1,0
		movwf		data_s1
		movf		tmr0_count2,0
		movwf		data_s2
		clrf			data_s3
		bcf			tmr1_flg,0

		call			data_mul
		call			data_mul
		call			data_mul
		
		call			data_mul
		call			data_mul
		call			data_mul
		call			data_mul

		call			dec_450
		
		call			hexdec32

		call			zero_check
		
		movf		hen_4,0
		call			suji_henkan1
		movwf		f_data1
		movf		hen_5,0
		call			suji_henkan1
		movwf		f_data2
		movf		hen_6,0
		call			suji_henkan1
		movwf		f_data3
		movf		hen_7,0
		call			suji_henkan1
		movwf		f_data4
		movf		hen_8,0
		call			suji_henkan1
		movwf		f_data5		

		goto		int_next9
		;----------------------------------
int_next3
		btfss		INTCON,TMR0IF
		goto		int_next9
		bcf			INTCON,TMR0IF
		movlw		01h
		addwf		tmr0_count1,1
		rlf			tmr0_count1,0
		andlw		01h
		addwf		tmr0_count2,1
		goto		int_next9
		;----------------------------------
		

		;----------------------------------
int_next9		
		movf    		status_temp,w	; retrieve copy of STATUS register
		movwf		STATUS		; restore pre-isr STATUS register contents
		swapf   		w_temp,f
		swapf  		 w_temp,w		; restore pre-isr W register contents
		retfie						; return from interrupt
;---------------------------------------------------------------------------------------
main
		call			osc_set
		call			port_set
		call			ad_set
		
		movlw		0ffh
		movwf		PORTA
		movlw		0ffh
		movwf		PORTB



		call			sel_clear
		
		clrf			tmr1_flg
		
		call			timer0_set
		call			timer1_set
		
		clrf			data_s0
		clrf			data_s1
		clrf			data_s2
		clrf			data_s3

;--------------------------------------
main_loop
		

		;--------------------------------- LED disp
main_loop2
		call			sel_clear
		movf		f_data1,0
		movwf		PORTB
		btfss		f_data1,6
		bcf			PORTA,6
		nop
		bsf			PORTA,0
		nop
		bcf			PORTA,1
		nop
		bsf			PORTA,2
		nop
		call			disp_time
;-------------------------
		movf		f_data2,0
		movwf		PORTB
		btfss		f_data2,6
		bcf			PORTA,6
		nop
		bcf			PORTA,0
		nop
		bcf			PORTA,1
		nop
		bsf			PORTA,2
		nop
		call			disp_time
;-------------------------
		movf		f_data3,0
		movwf		PORTB
		btfss		f_data3,6
		bcf			PORTA,6
		nop
		bsf			PORTA,0
		nop
		bsf			PORTA,1
		nop
		bcf			PORTA,2
		nop
		call			disp_time		
;-------------------------
		movf		f_data4,0
		movwf		PORTB
		btfss		f_data4,6
		bcf			PORTA,6
		nop
		bcf			PORTA,0
		nop
		bsf			PORTA,1
		nop
		bcf			PORTA,2
		nop
		call			disp_time		
;-------------------------
		movf		f_data5,0
		movwf		PORTB
		btfss		f_data5,6
		bcf			PORTA,6
		nop
		bsf			PORTA,0
		nop
		bcf			PORTA,1
		nop
		bcf			PORTA,2
		nop
		call			disp_time
;-------------------------


;---------------------------------------
		goto		main_loop
;-------------------------------------------------------------------------------
wait_20
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		return
;-------------------------------------------------------------------------------
wait_12
		movlw		2h
		movwf		wait_data_2
wait_12_2
		call			wait_1
		decfsz		wait_data_2,1
		goto		wait_12_2
		return

wait_11
		movlw		1h
		movwf		wait_data_2
wait_11_2
		call			wait_1
		decfsz		wait_data_2,1
		goto		wait_11_2
		return

wait_10
		movlw		1h
		movwf		wait_data_2
wait_10_2
		call			wait_1
		decfsz		wait_data_2,1
		goto		wait_10_2
		return

wait_0
		movlw		080h
		movwf		wait_data
		goto		wait_2
wait_1		
		movlw		0ffh
		movwf		wait_data
wait_2
		nop
		decfsz		wait_data,1
		goto		wait_2
		return
;-----------------------------------------------------------------------------
hexdec32:
		movlw		dec_top
		movwf		FSR
		call			devide
		call			devide
		call			devide
		call			devide
		call			devide
		call			devide
		call			devide
		call			devide
		call			devide
		call			devide
		return

devide:
		movlw		20h
		movwf		sub_count
		clrf			sub_amari
devide0:
		bcf			STATUS,0
		rlf			data_s0,1
		rlf			data_s1,1
		rlf			data_s2,1
		rlf			data_s3,1
		rlf			sub_amari,1
		movlw		0f6h
		addwf		sub_amari,0
		btfsc		STATUS,0
		movwf		sub_amari
		btfsc		STATUS,0
		incf		data_s0,1
		decfsz		sub_count,1
		goto		devide0
		decf		FSR,1
		movf		sub_amari,0
		movwf		INDF
		return		
;-----------------------------------------------------------------------------
sel_clear
		bsf			PORTA,0
		nop
		bsf			PORTA,1
		nop
		bsf			PORTA,2
		nop
		bsf			PORTA,6
		nop
		return
;-----------------------------------------------------------------------------
disp_time		
		call			wait_0
		call			sel_clear
		return
;------------------------------------------------------------------------------
suji_henkan1
		movwf	taihi
		movlw	low(suji_table1)
		addwf	taihi,1
		movlw	high(suji_table1)
		movwf	PCLATH
		addcf	PCLATH,1
		movf	taihi,0
		movwf	PCL
suji_table1
		;----------- 
		retlw	40h		;0
		retlw	79h		;1
		retlw	24h		;2
		retlw	30h		;3
		retlw	19h		;4
		retlw	12h		;5
		retlw	02h		;6
		retlw	58h		;7
		retlw	00h		;8
		retlw	10h		;9
		retlw	08h		;a
		retlw	0ch		;b
		retlw	00h		;c
		retlw	00h		;d
		retlw	00h		;e
		retlw	7fh		;f(space)
;------------------------------------------------------------------------------
dec_450
		movlw		0d0h
		subwf		data_s0,1
		movlw		01h
		btfss		STATUS,0
		subwf		data_s1,1
		btfss		STATUS,0
		subwf		data_s2,1
		btfss		STATUS,0
		subwf		data_s3,1
		
		movlw		0ddh
		subwf		data_s1,1
		movlw		01h
		btfss		STATUS,0
		subwf		data_s2,1
		btfss		STATUS,0
		subwf		data_s3,1
		
		movlw		06h
		subwf		data_s2,1
		movlw		01h
		btfss		STATUS,0
		subwf		data_s3,1
		
		return
;------------------------------------------------------------------------------
zero_check
		movf		hen_8,0
		btfss		STATUS,2
		return
		movlw		0fh
		movwf		hen_8
		movf		hen_7,0
		btfss		STATUS,2
		return
		movlw		0fh
		movwf		hen_7
		return
;------------------------------------------------------------------------------
data_mul
		bcf			STATUS,0		
		rlf			data_s0,1
		rlf			data_s1,1
		rlf			data_s2,1
		rlf			data_s3,1
		return
;------------------------------------------------------------------------------
banksel_0
		bcf			STATUS,RP0
		nop
		bcf			STATUS,RP1
		nop
		return
banksel_1
		bsf			STATUS,RP0
		nop
		bcf			STATUS,RP1
		nop
		return
banksel_2
		bcf			STATUS,RP0
		nop
		bsf			STATUS,RP1
		nop
		return
banksel_3
		bsf			STATUS,RP0
		nop
		bsf			STATUS,RP1
		nop
		return
;------------------------------------------------------------------------------
osc_set
		call			banksel_1
								;(0)NC
								;(110)IRCF2-IRCF0
								;(0)OSTS
								;(0)IOFS
								;(00)SCS
		movlw		60h
		movwf		OSCCON
		call			banksel_0
		return
;-------------------------------------------------------------------------------
port_set							;RA0,RA1,RA2,RA3,RA6(OUT)
								;RA4,RA5,RA7(IN)
								;RB0,RB1,RB2,RB3,RA4,RA5(OUT)
								;RB6,RB7(IN)
		call			banksel_1
		clrf			TRISA
		bsf			TRISA,4
		nop
		bsf			TRISA,5
		nop
		bsf			TRISA,7
		nop
		clrf			TRISB
		bsf			TRISB,6
		nop
		bsf			TRISB,7
		nop
		call			banksel_0
		return
;------------------------------------------------------------------------------
ad_set
								;(01)ADCS1,ADCS0
								;(000)CHS2,CHS1,CHS0
								;(0)GO/DONE
								;(0)NC
								;(0)ADON
		movlw		40h
		movwf		ADCON0
		call			banksel_1
								;(0)ADFM
								;(1)ADCS2
								;(00)VCFG1,VCFG0
								;(0000)
		movlw		040h
		movwf		ADCON1
								;(0)NC
								;(0000000)ANS6-ANS0
		movlw		00h
		movwf		ANSEL
		call			banksel_0
		return
;-------------------------------------------------------------------------------
timer0_set

		call			banksel_1
		movlw		0e0h		;(1)PORTB NOT PULLUP
								;(1)INTEDG
								;(1)TOCS
								;(0)TOSE
								;(0)PSA
								;(000)1/2
		movwf		OPTION_REG
		call			banksel_0

		clrf			TMR0
		bsf			INTCON,TMR0IE
		bsf			INTCON,GIE
		return
;------------------------------------------------------------------------------
timer1_set
								;(0)NC
								;(0)T1RUN
								;(00)T1CKPS1,T1CKPS0
								;(1)T1OSCEN
								;(0)T1SYNC
								;(1)TMR1CS
								;(1)TMR1ON
		movlw		0bh
		movwf		T1CON
		movlw		set_timer1
		movwf		TMR1H
		movlw		00h
		movwf		TMR1L

		call			banksel_1		
		bsf			PIE1,TMR1IE
		call			banksel_0
		bsf			INTCON,PEIE
		bsf			INTCON,GIE
		return	
;-------------------------------------------------------------------------------

		end                     ; directive 'end of program'
